---
title: 常用的内置模块
date: 2024-06-06T23:51:22Z
tags: []
---

## 导入

```python
import 模块名称 [as 别名]
```

```python
from 模块名称 import 变量/函数/类/*
```

## os模块

> 与操作系统和文件相关操作有关的模块

`getcwd()`:获取当前工作路径

`listdir(path)`:获取path路径下的文件,如果没有指定path,则获取当前路径下的文件和目录信息

`mkdir(path)`:在指定路径下创建目录(文件夹)

`makedirs(path)`:创建多级目录

### os.path模块

​`abspath(path)`​:获取目录或文件的绝对路径  

​`exists(path)`​:判断目录或文件在磁盘上是否存在,结果为bool类型,如果目录或文件在磁盘上存在,结果为True,否则为False  

​`join(path.name)`​:将目录与文件名进行拼接,相当于字符串`+`​的操作  

​`splitext()`​:分别获取文件名和后缀

## re模块

> 用于在Python的字符串中执行正则表达式[^1]的模块

## random模块

> 用于产生随机数的模块

​`seed(x)`​:初始化给定的随机数种子,默认为当前系统时间  

​`random()`​:产生一个[0.0,1.0]之间的随机小数  

​`randint(a,b)`生成一个[a,b]之间的整数  

​`randrange(m,n,k)`​生成一个[m,n)之间步长为k的随机整数  

​`uniform(a,b)`​:生成一个[a,b]之间的随机小数  

​`choice(seq)`​:从序列中随机选择一个数  

​`shuffle(seq)`​:将序列seq中元素随机排列,然后打乱后的序列

## json模块

> 用于对高维数据进行编码和解码的模块

`json.dumps(obj)`:将python数据类型转为json格式过程,编码过程

`json.loads(s)`:将JSON格式字符串转为python数据类型,解码过程

`json.dump(obj,file)`:与dumps功能相同,将转换结果储存到文件file中

`json.load(file)`:与loads功能相同,从文件a中读入数据

## time模块

> 与时间相关的模块

​`time()`​:获取当前时间戳  

​`localtime(sec)`​:获取指定时间戳对应的本地时间的structural_time对象  

​`ctime()`​:获取当前时间戳对应的易读字符串  

​`strftime()`​:格式化时间结果为字符串  

​`strptime()`​:提取字符串的时间,结果为字符串  

​`sleep(sec)`​:休眠sec秒

## datetime模块

> 与日期相关的模块,可以方便的显示日期并对日期进行运算

​`datetime`​:表示日期时间类  

​`timedelta`​:表示时间间隔的类  

​`date`​:表示日期的类  

​`time`​:表示时间的类  

​`tzinfo`​:时区相关的类
